;BeginWork:27.03.2018
;End__Work:
format PE64 native 5.02;
include 'd:\fasm\include\win64w.inc'
include 'D:\Asm\pro\Include\Inc\DrHeader_64\My_ntddk_x64.inc'
include 'D:\Asm\pro\Include\Inc\DrHeader_64\My_ntstatus_x64.inc' 
entry DriverEntry;
;________STRUCTURE______________________________________________________________
    struc _UNICODE_STRING Length, MaxLength, Buffer
       {
         .Length            dw  Length; 
         .MaximumLength     dw  MaxLength;
         .unnamedraw        dd  ?
         .Buffer            dq  Buffer;
       }
;________CONSTANT_______________________________________________________________

;________MACRO__________________________________________________________________
	macro UNICODE_STRING_DEFINE Name,_String 
        {
         _#Name             du _String
         Name#_Len = $ - _#Name;
                            dw 0;
         Name#_Max = Name#_Len + 2;
         Name _UNICODE_STRING  Name#_Len, Name#_Max, _#Name;
        } 

    macro IOCTL_DEFINE_EX Name,_DeviceType,_Access,_Function,_Method
        {
         Name equ (_DeviceType shl 16) or (_Access shl 14) or (_Function shl 2) or (_Method)
        } 
;________CODE___________________________________________________________________
 section '_code' code readable writeable executable 
     ;data 
         DeviceObject    				dq   ?;
         mask_string                    db   '%s',13,10,0

         str_DriverEntry                db   'DriveEntry load',0;
         str_DispatchCreate             db   'DispatchCreate load',0;
         str_DispatchClose              db   'DispatchClose load',0;
         str_DispatchControl            db   'DispatchControl load',0;
         IDTR:
              .Limit                    dw   ?;
              .Base                     dq   ?;
         UNICODE_STRING_DEFINE str_DeviceName,"\Device\devIDTDump";
         UNICODE_STRING_DEFINE str_SymbolicName,"\??\IDTDUMP";
         IOCTL_DEFINE_EX IOCTL_IDT,FILE_DEVICE_UNKNOWN,FILE_ANY_ACCESS,1,METHOD_BUFFERED
 ;_______DriverEntry____________________________________________________________
     proc DriverEntry pDriverObject,pusRegistryPath
                 mov [pDriverObject],rcx;
                 mov [pusRegistryPath],rdx;
                 local status:QWORD;
                 
                 invoke DbgPrintEx,DPFLTR_IHVDRIVER_ID,0,mask_string,str_DriverEntry 
                 
                 mov rax,STATUS_DEVICE_CONFIGURATION_ERROR 
                 mov [status],rax;
            ;create DeviceObject
                 invoke IoCreateDevice,[pDriverObject],0,str_DeviceName,\
                 FILE_DEVICE_UNKNOWN,0,FALSE,DeviceObject;
                 cmp rax,STATUS_SUCCESS
                 jnz .error;
            ;create Symbolink 
                 invoke IoCreateSymbolicLink,str_SymbolicName,str_DeviceName; 
                 cmp rax,STATUS_SUCCESS
                 jnz .error;

            ;filling majoir funciont in DriveObject
                 mov rax,[pDriverObject];
                 virtual at rax;
                      .rax DRIVER_OBJECT
                 end virtual        
                 mov rdx, DispatchCreate;
                 mov qword[.rax.MajorFunction+IRP_MJ_CREATE*8],rdx;
                 mov rdx, DispatchClose;
                 mov qword[.rax.MajorFunction+IRP_MJ_CLOSE*8],rdx;
                 mov rdx, DispatchControl
                 mov qword[.rax.MajorFunction+IRP_MJ_DEVICE_CONTROL*8],rdx;
                 mov rdx, DriverUnloadHandler;
                 mov qword[.rax.DriverUnload],rdx;
                 mov [status],STATUS_SUCCESS;
                 jmp .exit;
            .error:
                 mov [status],rax;
                 invoke IoDeleteDevice,[DeviceObject]
                 
            .exit:
                 mov rax,[status];
     ret;
     endp;   
 ;_______DispatchCreate_________________________________________________________
     proc DispatchCreate pDeviceObject,pIRP
                mov [pIRP],rdx 
                invoke DbgPrintEx,DPFLTR_IHVDRIVER_ID,0,mask_string,str_DispatchCreate
                invoke IofCompleteRequest,[pIRP],IO_NO_INCREMENT;
                mov rax,STATUS_SUCCESS;
     ret;
     endp;
 ;_______DispatchClose__________________________________________________________
     proc DispatchClose pDeviceObject,pIRP 
                mov [pIRP],rdx 
                invoke DbgPrintEx,DPFLTR_IHVDRIVER_ID,0,mask_string,str_DispatchClose
                invoke IofCompleteRequest,[pIRP],IO_NO_INCREMENT;
                mov rax,STATUS_SUCCESS;
     ret;
     endp;
 ;_______DispatchControl________________________________________________________            
     proc DispatchControl pDeviceObject,pIRP 
                mov [pDeviceObject],rcx;
                mov [pIRP],rdx;
                local status:QWORD
                invoke DbgPrintEx,DPFLTR_IHVDRIVER_ID,0,mask_string,str_DispatchControl
              
            ;default value output inforamtion    
                mov rax,STATUS_DEVICE_CONFIGURATION_ERROR;
                mov [status],rax;
                mov r8,[pIRP]
                virtual at r8
                    .r8 _IRP 
                end virtual
                mov r9,[.r8.Tail.Overlay.CurrentStackLocation];
                virtual at r9 
                    .r9 IO_STACK_LOCATION
                end virtual 
                mov [.r8.IoStatus.Information],0;    bad buffer 

            ;if control code not equal, exit 
                cmp [.r9.IoControlCode],IOCTL_IDT;
                jnz .exit 
                sidt tword[IDTR];
                xor  rcx,rcx;
                mov  cx,[IDTR.Limit];
                inc  rcx;
            ;if buffer for output to small, exit    
                mov  rax,STATUS_BUFFER_TOO_SMALL
                mov  [status],rax;
                cmp  [.r9.OutputBufferLength01],ecx
                jb   .exit;
            ;copy from base idtr in output buffer 
                mov  [.r8.IoStatus.Information],rcx;        size buffer  
                push rdi rsi
                mov  rdi,[.r8.SystemBuffer];                copy 
                mov  rsi,[IDTR.Base];
                rep movsb 
                pop  rsi rdi 
                mov  [.r8.IoStatus.Status],0;
                xor  rax,rax;
                mov  [status],rax;
                invoke IofCompleteRequest,[pIRP],IO_NO_INCREMENT;
            .exit:
                mov rax,[status];

     ret;
     endp;
 ;_______DriverUnloadHandler____________________________________________________
     proc DriverUnloadHandler pDeviceObject,pIRP;
                invoke IoDeleteSymbolicLink, str_SymbolicName
                invoke IoDeleteDevice, [DeviceObject]
     ret;
     endp;
;________RELOCATION_____________________________________________________________
 section '_relocs' fixups  readable writeable discardable;
;________IMPORT_________________________________________________________________
 section '_import' import data readable writeable;
 
 library	 ntoskrnl,'ntoskrnl.exe';

 import      ntoskrnl,\
             DbgBreakPoint,'DbgBreakPoint',\
             IoCreateDevice,'IoCreateDevice',\
             IoDeleteDevice,'IoDeleteDevice',\
             IoCreateSymbolicLink,'IoCreateSymbolicLink',\
             IofCompleteRequest,'IofCompleteRequest',\
             IoDeleteSymbolicLink,'IoDeleteSymbolicLink',\
             DbgPrintEx,'DbgPrintEx'
                       
  